/*
#include <stddef.h>
*/

#ifndef	CH3D_I
#define CH3D_I	int
#endif

#ifndef	CH3D_U
#define CH3D_U	unsigned
#endif

typedef struct {
		CH3D_I	*x,*y,*z;
		CH3D_U	para1,para2,para3,para4,para5,
			*name,*ve,*fe,*sv,*ev,*rf,*lf,*sce,*scce,*ece,*ecce,
			*wv1,*wv2,*wv3,*wv4,*wv5,*wv6,*we1,*we2,*wf1,*wf2,
			Nv1,Ne1,Nf1,Nv2,Ne2,Nf2;
	} CH3D_T;

extern CH3D_T	*InitCH3D(CH3D_U Np_limit);
extern void	TermCH3D(CH3D_T *ch3d),
		CH3D(CH3D_T *ch3d,CH3D_U Np,int set_name),
		CH3D_e2p(CH3D_T *ch3d,CH3D_U e,CH3D_U p[/* 2 */]),
		CH3D_f2p(CH3D_T *ch3d,CH3D_U f,CH3D_U p[/* 3 */]),
		CH3D_f2e(CH3D_T *ch3d,CH3D_U f,CH3D_U e[/* 3 */]);
extern int	CH3D_TL(CH3D_U p0,CH3D_U p1,CH3D_U p2,
			CH3D_I *x,CH3D_I *y,CH3D_U *name),
		CH3D_OR(CH3D_U p[/* 4 */],
			CH3D_I *x,CH3D_I *y,CH3D_I *z,CH3D_U *name);

#define CH3D_MIN	((CH3D_I)1<<sizeof(CH3D_I)*8-1)
#define CH3D_MAX	(CH3D_I)(~CH3D_MIN)
#define CH3D_LIM	(~(CH3D_U)0)

#define CH3D_X(ch3d)	(ch3d->x)
#define CH3D_Y(ch3d)	(ch3d->y)
#define CH3D_Z(ch3d)	(ch3d->z)

#define CH3D_P2V(ch3d,p)	(ch3d->wv1)[p]
#define CH3D_V2P(ch3d,v)	(ch3d->wv2)[v]
