
#include <stdio.h>
#include <stdlib.h>
#include "ch3d.h"

#define UL	unsigned long

int	main()
{
	UL	N,n,v,e;
	CH3D_T	*ch3d;
	double	x,y,z;

	if (scanf("%lu",&N)!=1 || N<4) exit(1);

	ch3d=InitCH3D((CH3D_U)N);

	for (n=0; n<N; n++) {
	    if (scanf("%lf %lf %lf",&x,&y,&z)!=3) exit(1);

	    ch3d->x[n]=(CH3D_I)x; ch3d->y[n]=(CH3D_I)y; ch3d->z[n]=(CH3D_I)z;
	}
	CH3D(ch3d,(CH3D_U)N,0);

	(void)printf("%lu\t%lu\t%lu\n"
		     "+%lu\t+%lu\t+%lu\n",
		     (UL)ch3d->Nv1,(UL)ch3d->Nf1,(UL)ch3d->Ne1,
		     (UL)ch3d->Nv2,(UL)ch3d->Nf2,(UL)ch3d->Ne2);

	for (n=0; n<ch3d->Nv2; n++) {
	    if (n>=ch3d->Nv1) (void)putchar('+');

	    v=ch3d->wv2[n];
	    (void)printf("%lu\t%lu\t%ld\t%ld\t%ld\n",
			 n,(UL)ch3d->we1[ch3d->ve[v]],
			   (long)ch3d->x[v],(long)ch3d->y[v],(long)ch3d->z[v]);
	}
	for (n=0; n<ch3d->Nf2; n++) {
	    if (n>=ch3d->Nf1) (void)putchar('+');

	    (void)printf("%lu\t%lu\n",n,(UL)ch3d->we1[ch3d->fe[ch3d->wf2[n]]]);
	}
	for (n=0; n<ch3d->Ne2; n++) {
	    if (n>=ch3d->Ne1) (void)putchar('+');

	    e=ch3d->we2[n];
	    (void)printf("%lu\t%lu\t%lu\t%lu\t%lu\t%lu\t%lu\t%lu\t%lu\n",
			 n,(UL)ch3d->wv1[ch3d->sv[e]],
			   (UL)ch3d->wv1[ch3d->ev[e]],
			   (UL)ch3d->wf1[ch3d->rf[e]],
			   (UL)ch3d->wf1[ch3d->lf[e]],
			   (UL)ch3d->we1[ch3d->sce[e]],
			   (UL)ch3d->we1[ch3d->scce[e]],
			   (UL)ch3d->we1[ch3d->ece[e]],
			   (UL)ch3d->we1[ch3d->ecce[e]]);
	}
	TermCH3D(ch3d); return 0;
}
